# encoding: UTF-8
# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20160428093204) do

  create_table "account_ribs", force: :cascade do |t|
    t.integer  "product_customer_id", limit: 4
    t.string   "bank_name",           limit: 255
    t.string   "bank_city",           limit: 255
    t.string   "country",             limit: 255
    t.string   "name",                limit: 255
    t.string   "address",             limit: 255
    t.string   "address2",            limit: 255
    t.string   "cp",                  limit: 255
    t.string   "city",                limit: 255
    t.string   "iban",                limit: 255
    t.string   "bic",                 limit: 255
    t.string   "tva_number",          limit: 255
    t.boolean  "tva",                 limit: 1
    t.boolean  "enabled",             limit: 1
    t.boolean  "validated",           limit: 1
    t.datetime "validated_at"
    t.boolean  "archived",            limit: 1
    t.datetime "archived_at"
    t.string   "scan_file",           limit: 255
    t.datetime "created_at",                      null: false
    t.datetime "updated_at",                      null: false
  end

  add_index "account_ribs", ["product_customer_id"], name: "index_account_ribs_on_product_customer_id", using: :btree

  create_table "admins", force: :cascade do |t|
    t.string   "name",                   limit: 255
    t.string   "firstname",              limit: 255
    t.string   "avatar",                 limit: 255
    t.string   "username",               limit: 255, default: "", null: false
    t.string   "email",                  limit: 255, default: "", null: false
    t.string   "password_digest",        limit: 255, default: "", null: false
    t.string   "reset_password_token",   limit: 255
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",          limit: 4,   default: 0
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip",     limit: 255
    t.string   "last_sign_in_ip",        limit: 255
    t.string   "remember_token",         limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "cms",                    limit: 1
    t.boolean  "transactions",           limit: 1
    t.boolean  "orders",                 limit: 1
    t.boolean  "petitions",              limit: 1
    t.boolean  "donators",               limit: 1
    t.boolean  "newsletter",             limit: 1
    t.boolean  "moderateur",             limit: 1
  end

  create_table "albums", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.boolean  "super_admin", limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "article_authors", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.text     "description", limit: 65535
    t.boolean  "enabled",     limit: 1
    t.datetime "created_at",                null: false
    t.datetime "updated_at",                null: false
    t.string   "title",       limit: 255
    t.string   "url",         limit: 255
  end

  create_table "articles", force: :cascade do |t|
    t.datetime "published_at"
    t.string   "title",             limit: 255
    t.string   "slug",              limit: 255
    t.string   "tag",               limit: 255
    t.text     "description",       limit: 65535
    t.text     "keywords",          limit: 65535
    t.boolean  "enabled",           limit: 1
    t.integer  "image_file_id",     limit: 4
    t.boolean  "title_cached",      limit: 1
    t.string   "tags_cache",        limit: 255
    t.string   "tags_cache_slug",   limit: 255
    t.integer  "category_id",       limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "thumb_style",       limit: 255
    t.boolean  "commentable",       limit: 1
    t.boolean  "show_comments",     limit: 1
    t.integer  "title_bottom",      limit: 4
    t.boolean  "gradient_cached",   limit: 1
    t.integer  "article_author_id", limit: 4
  end

  add_index "articles", ["article_author_id"], name: "index_articles_on_article_author_id", using: :btree

  create_table "block_contents", force: :cascade do |t|
    t.integer  "style",            limit: 4
    t.integer  "nbr_columns",      limit: 4
    t.integer  "row1",             limit: 4
    t.integer  "row2",             limit: 4
    t.integer  "row3",             limit: 4
    t.integer  "row4",             limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "image_file_id",    limit: 4
    t.integer  "margin_top",       limit: 4
    t.integer  "margin_bottom",    limit: 4
    t.integer  "margin_left",      limit: 4
    t.integer  "margin_right",     limit: 4
    t.integer  "padding_top",      limit: 4
    t.integer  "padding_bottom",   limit: 4
    t.integer  "padding_left",     limit: 4
    t.integer  "padding_right",    limit: 4
    t.boolean  "parallax",         limit: 1
    t.boolean  "center",           limit: 1
    t.integer  "center_width",     limit: 4
    t.string   "background_color", limit: 255
    t.string   "gradient_start",   limit: 255
    t.string   "gradient_stop",    limit: 255
  end

  add_index "block_contents", ["image_file_id"], name: "index_block_contents_on_image_file_id", using: :btree

  create_table "blocks", force: :cascade do |t|
    t.integer  "lang_site_id",   limit: 4
    t.string   "block_name",     limit: 255
    t.string   "blockable_type", limit: 255
    t.integer  "blockable_id",   limit: 4
    t.text     "content",        limit: 65535
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "break_contents", force: :cascade do |t|
    t.boolean  "line",       limit: 1
    t.integer  "height",     limit: 4
    t.string   "style",      limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "categories", force: :cascade do |t|
    t.string   "name",          limit: 255
    t.string   "slug",          limit: 255
    t.boolean  "enabled",       limit: 1
    t.text     "description",   limit: 65535
    t.integer  "image_file_id", limit: 4
    t.integer  "position",      limit: 4
    t.integer  "parent_id",     limit: 4
    t.string   "permalink",     limit: 255
    t.boolean  "front_page",    limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "cel_tables", force: :cascade do |t|
    t.integer  "position",         limit: 4
    t.integer  "style",            limit: 4
    t.integer  "table_row_id",     limit: 4
    t.integer  "table_content_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "comments", force: :cascade do |t|
    t.string   "pseudo",           limit: 255,   default: ""
    t.string   "email",            limit: 255,   default: ""
    t.string   "website",          limit: 255,   default: ""
    t.boolean  "enabled",          limit: 1
    t.text     "comment",          limit: 65535
    t.integer  "commentable_id",   limit: 4
    t.string   "commentable_type", limit: 255
    t.integer  "user_id",          limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "parent_id",        limit: 4
    t.boolean  "newsletter",       limit: 1
  end

  create_table "commissions", force: :cascade do |t|
    t.integer  "product_customer_id", limit: 4
    t.decimal  "amount",                        precision: 10, scale: 2
    t.boolean  "canceled",            limit: 1
    t.datetime "canceled_at"
    t.integer  "commission_type_id",  limit: 4
    t.integer  "order_id",            limit: 4
    t.datetime "created_at",                                             null: false
    t.datetime "updated_at",                                             null: false
    t.integer  "canceled_id",         limit: 4
    t.integer  "binary_point_id",     limit: 4
    t.integer  "count_part_com_id",   limit: 4
    t.decimal  "percent",                       precision: 10, scale: 2
    t.integer  "generation",          limit: 4
    t.integer  "devise_id",           limit: 4
  end

  add_index "commissions", ["count_part_com_id"], name: "index_commissions_on_count_part_com_id", using: :btree
  add_index "commissions", ["devise_id"], name: "index_commissions_on_devise_id", using: :btree
  add_index "commissions", ["product_customer_id"], name: "index_commissions_on_product_customer_id", using: :btree

  create_table "data_file_categories", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "slug",       limit: 255
    t.integer  "parent_id",  limit: 4
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "data_files", force: :cascade do |t|
    t.string   "file",                  limit: 255
    t.string   "name",                  limit: 255
    t.string   "slug",                  limit: 255
    t.string   "token",                 limit: 255
    t.string   "description",           limit: 255
    t.integer  "file_folder_id",        limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "title",                 limit: 255
    t.text     "long_desc",             limit: 65535
    t.boolean  "boutique",              limit: 1
    t.integer  "data_file_category_id", limit: 4
    t.integer  "image_file_id",         limit: 4
  end

  add_index "data_files", ["image_file_id"], name: "index_data_files_on_image_file_id", using: :btree

  create_table "devises", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.string   "icon",        limit: 255
    t.string   "code",        limit: 255
    t.decimal  "rate",                    precision: 10, scale: 2
    t.string   "text_format", limit: 255
    t.datetime "created_at",                                       null: false
    t.datetime "updated_at",                                       null: false
    t.boolean  "orderable",   limit: 1
  end

  create_table "download_contents", force: :cascade do |t|
    t.string   "title",        limit: 255
    t.string   "style",        limit: 255
    t.text     "description",  limit: 65535
    t.integer  "data_file_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "dynamic_contents", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "external_links", force: :cascade do |t|
    t.string   "title",       limit: 255
    t.text     "description", limit: 65535
    t.string   "url",         limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "file_folders", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.boolean  "super_admin", limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "gallery_contents", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.text     "description", limit: 65535
    t.integer  "style",       limit: 4
    t.integer  "nbr_img",     limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "gallery_images", force: :cascade do |t|
    t.string   "title",              limit: 255
    t.text     "description",        limit: 65535
    t.string   "tags",               limit: 255
    t.integer  "position",           limit: 4
    t.integer  "image_file_id",      limit: 4
    t.integer  "gallery_content_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "home_slider_slides", force: :cascade do |t|
    t.integer  "home_slider_id", limit: 4
    t.integer  "position",       limit: 4
    t.datetime "start_at"
    t.datetime "end_at"
    t.integer  "image_file_id",  limit: 4
    t.boolean  "enabled",        limit: 1
    t.datetime "created_at",                 null: false
    t.datetime "updated_at",                 null: false
    t.string   "url",            limit: 255
  end

  add_index "home_slider_slides", ["home_slider_id"], name: "index_home_slider_slides_on_home_slider_id", using: :btree

  create_table "home_sliders", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "slug",       limit: 255
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "html_contents", force: :cascade do |t|
    t.text     "content",      limit: 65535
    t.string   "style",        limit: 255
    t.string   "content_type", limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "image_contents", force: :cascade do |t|
    t.integer  "image_file_id", limit: 4
    t.integer  "width",         limit: 4
    t.integer  "height",        limit: 4
    t.string   "alignement",    limit: 255
    t.boolean  "expandable",    limit: 1
    t.string   "style",         limit: 255
    t.string   "alt",           limit: 255
    t.integer  "cible_id",      limit: 4
    t.string   "cible_type",    limit: 255
    t.boolean  "with_cible",    limit: 1
    t.boolean  "popup",         limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "margin_top",    limit: 4
    t.integer  "margin_left",   limit: 4
    t.integer  "margin_right",  limit: 4
    t.integer  "margin_bottom", limit: 4
  end

  create_table "image_files", force: :cascade do |t|
    t.string   "file",        limit: 255
    t.string   "name",        limit: 255
    t.string   "slug",        limit: 255
    t.text     "description", limit: 65535
    t.string   "tags",        limit: 255
    t.integer  "album_id",    limit: 4
    t.string   "photograph",  limit: 255
    t.string   "cible_type",  limit: 255
    t.integer  "cible_id",    limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "lang_articles", force: :cascade do |t|
    t.datetime "published_at"
    t.string   "title",           limit: 255
    t.string   "slug",            limit: 255
    t.text     "description",     limit: 65535
    t.text     "keywords",        limit: 65535
    t.boolean  "enabled",         limit: 1
    t.integer  "image_file_id",   limit: 4
    t.boolean  "title_cached",    limit: 1
    t.string   "tags_cache",      limit: 255
    t.string   "tags_cache_slug", limit: 255
    t.integer  "lang_site_id",    limit: 4
    t.integer  "article_id",      limit: 4
    t.datetime "created_at",                    null: false
    t.datetime "updated_at",                    null: false
  end

  create_table "lang_pages", force: :cascade do |t|
    t.integer  "lang_site_id", limit: 4
    t.integer  "page_id",      limit: 4
    t.text     "title",        limit: 65535
    t.text     "description",  limit: 65535
    t.text     "keywords",     limit: 65535
    t.datetime "created_at",                 null: false
    t.datetime "updated_at",                 null: false
  end

  add_index "lang_pages", ["lang_site_id"], name: "index_lang_pages_on_lang_site_id", using: :btree
  add_index "lang_pages", ["page_id"], name: "index_lang_pages_on_page_id", using: :btree

  create_table "lang_sites", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "slug",       limit: 255
    t.boolean  "enabled",    limit: 1
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "link_contents", force: :cascade do |t|
    t.integer  "type",       limit: 4
    t.string   "name",       limit: 255
    t.string   "title",      limit: 255
    t.boolean  "popup",      limit: 1
    t.string   "url",        limit: 255
    t.string   "style",      limit: 255
    t.integer  "cible_id",   limit: 4
    t.string   "cible_type", limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "map_contents", force: :cascade do |t|
    t.string   "address",    limit: 255
    t.string   "name",       limit: 255
    t.integer  "view",       limit: 4
    t.boolean  "info_bule",  limit: 1
    t.integer  "zoom",       limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "menu_aliases", force: :cascade do |t|
    t.integer  "menu_item_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "menu_item_langs", force: :cascade do |t|
    t.integer  "lang_site_id", limit: 4
    t.string   "name",         limit: 255
    t.string   "slug",         limit: 255
    t.string   "permalink",    limit: 255
    t.boolean  "enabled",      limit: 1
    t.boolean  "visible",      limit: 1
    t.integer  "menu_item_id", limit: 4
    t.datetime "created_at",               null: false
    t.datetime "updated_at",               null: false
  end

  add_index "menu_item_langs", ["lang_site_id"], name: "index_menu_item_langs_on_lang_site_id", using: :btree

  create_table "menu_item_link_contents", force: :cascade do |t|
    t.integer  "menu_item_id",  limit: 4
    t.integer  "image_file_id", limit: 4
    t.string   "title",         limit: 255
    t.text     "description",   limit: 65535
    t.string   "url",           limit: 255
    t.boolean  "popup",         limit: 1
    t.string   "style",         limit: 255
    t.string   "block_type",    limit: 255
    t.integer  "cible_id",      limit: 4
    t.string   "cible_type",    limit: 255
    t.decimal  "proportion",                  precision: 15, scale: 10
    t.integer  "level",         limit: 4
    t.datetime "created_at",                                            null: false
    t.datetime "updated_at",                                            null: false
  end

  add_index "menu_item_link_contents", ["image_file_id"], name: "index_menu_item_link_contents_on_image_file_id", using: :btree
  add_index "menu_item_link_contents", ["menu_item_id"], name: "index_menu_item_link_contents_on_menu_item_id", using: :btree

  create_table "menu_items", force: :cascade do |t|
    t.string   "name",              limit: 255
    t.string   "slug",              limit: 255
    t.string   "permalink",         limit: 255
    t.integer  "image_file_id",     limit: 4
    t.string   "section_name",      limit: 255
    t.integer  "section_id",        limit: 4
    t.string   "repertoire_name",   limit: 255
    t.integer  "repertoire_id",     limit: 4
    t.integer  "parent_id",         limit: 4
    t.integer  "position",          limit: 4
    t.boolean  "super_admin",       limit: 1
    t.boolean  "enabled",           limit: 1
    t.boolean  "visible",           limit: 1
    t.boolean  "deleted",           limit: 1
    t.integer  "menu_id",           limit: 4
    t.integer  "menu_content_id",   limit: 4
    t.string   "menu_content_type", limit: 255
    t.integer  "archive_id",        limit: 4
    t.boolean  "archived",          limit: 1
    t.datetime "archived_at"
    t.boolean  "password",          limit: 1
    t.boolean  "comment",           limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "sidebar",           limit: 1
    t.boolean  "title_image",       limit: 1
    t.string   "title_image_style", limit: 255
  end

  create_table "menu_urls", force: :cascade do |t|
    t.string   "url",        limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "menus", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "max_levels", limit: 255
    t.string   "slug",       limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "newsletters", force: :cascade do |t|
    t.string   "subject",    limit: 255
    t.text     "content",    limit: 65535
    t.boolean  "sended",     limit: 1
    t.boolean  "send_at",    limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "special",    limit: 1
    t.string   "slug",       limit: 255
  end

  create_table "pages", force: :cascade do |t|
    t.text     "title",        limit: 65535
    t.text     "description",  limit: 65535
    t.text     "keywords",     limit: 65535
    t.integer  "lang_site_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "pages", ["lang_site_id"], name: "index_pages_on_lang_site_id", using: :btree

  create_table "particulars", force: :cascade do |t|
    t.boolean  "pro",             limit: 1
    t.string   "organisation",    limit: 255
    t.string   "name",            limit: 255
    t.string   "firstname",       limit: 255
    t.string   "address_1",       limit: 255
    t.string   "address_2",       limit: 255
    t.string   "address_3",       limit: 255
    t.string   "address_4",       limit: 255
    t.string   "address_5",       limit: 255
    t.string   "cp",              limit: 255
    t.string   "city",            limit: 255
    t.string   "country",         limit: 255
    t.string   "tel",             limit: 255
    t.string   "email",           limit: 255
    t.string   "tel2",            limit: 255
    t.string   "tel3",            limit: 255
    t.string   "fax",             limit: 255
    t.string   "owner_type",      limit: 255
    t.integer  "owner_id",        limit: 4
    t.string   "particular_type", limit: 255
    t.boolean  "skip_validation", limit: 1
    t.datetime "created_at",                  null: false
    t.datetime "updated_at",                  null: false
  end

  create_table "portlets", force: :cascade do |t|
    t.integer  "block_id",     limit: 4
    t.integer  "content_id",   limit: 4
    t.string   "content_type", limit: 255
    t.integer  "position",     limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "product_categories", force: :cascade do |t|
    t.integer  "parent_id",           limit: 4
    t.datetime "created_at",                        null: false
    t.datetime "updated_at",                        null: false
    t.integer  "position",            limit: 4
    t.text     "description",         limit: 65535
    t.integer  "image_file_id",       limit: 4
    t.string   "color",               limit: 255
    t.integer  "image_file_left_id",  limit: 4
    t.integer  "image_file_right_id", limit: 4
    t.integer  "top_image_id",        limit: 4
  end

  create_table "product_category_langs", force: :cascade do |t|
    t.string   "name",                limit: 255
    t.string   "slug",                limit: 255
    t.string   "lang",                limit: 255
    t.integer  "product_category_id", limit: 4
    t.datetime "created_at",                        null: false
    t.datetime "updated_at",                        null: false
    t.text     "description",         limit: 65535
  end

  add_index "product_category_langs", ["product_category_id"], name: "index_product_category_langs_on_product_category_id", using: :btree

  create_table "product_collection_langs", force: :cascade do |t|
    t.string   "name",                  limit: 255
    t.string   "slug",                  limit: 255
    t.string   "lang",                  limit: 255
    t.integer  "product_collection_id", limit: 4
    t.datetime "created_at",                          null: false
    t.datetime "updated_at",                          null: false
    t.text     "description",           limit: 65535
  end

  add_index "product_collection_langs", ["product_collection_id"], name: "index_product_collection_langs_on_product_collection_id", using: :btree

  create_table "product_collections", force: :cascade do |t|
    t.integer  "product_category_id", limit: 4
    t.datetime "created_at",                      null: false
    t.datetime "updated_at",                      null: false
    t.integer  "image_fille_id",      limit: 4
    t.string   "color",               limit: 255
  end

  add_index "product_collections", ["product_category_id"], name: "index_product_collections_on_product_category_id", using: :btree

  create_table "product_customers", force: :cascade do |t|
    t.string   "email",                  limit: 255
    t.string   "password_digest",        limit: 255, default: "",    null: false
    t.string   "reset_password_token",   limit: 255
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",          limit: 4,   default: 0
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip",     limit: 255
    t.string   "last_sign_in_ip",        limit: 255
    t.boolean  "lock",                   limit: 1
    t.datetime "locked_at"
    t.datetime "created_at",                                         null: false
    t.datetime "updated_at",                                         null: false
    t.string   "remote_ip",              limit: 255
    t.string   "token",                  limit: 255
    t.boolean  "particular_idem",        limit: 1,   default: false
    t.integer  "particular_bill_id",     limit: 4
    t.integer  "particular_send_id",     limit: 4
    t.integer  "parent_id",              limit: 4
    t.string   "mlm_token",              limit: 255
    t.boolean  "parent_at_create",       limit: 1
    t.string   "parent_code",            limit: 255
    t.string   "provider",               limit: 255
    t.string   "uid",                    limit: 255
    t.string   "facebook_token",         limit: 255
  end

  create_table "product_fdps", force: :cascade do |t|
    t.decimal  "price",                         precision: 10, scale: 2
    t.text     "country",         limit: 65535
    t.string   "fdp_description", limit: 255
    t.decimal  "price_max",                     precision: 10, scale: 2
    t.string   "delais",          limit: 255
    t.datetime "created_at",                                             null: false
    t.datetime "updated_at",                                             null: false
    t.boolean  "archived",        limit: 1
  end

  create_table "product_images", force: :cascade do |t|
    t.string   "title",         limit: 255
    t.text     "description",   limit: 65535
    t.integer  "position",      limit: 4
    t.integer  "image_file_id", limit: 4
    t.integer  "product_id",    limit: 4
    t.datetime "created_at",                  null: false
    t.datetime "updated_at",                  null: false
  end

  add_index "product_images", ["image_file_id"], name: "index_product_images_on_image_file_id", using: :btree

  create_table "product_langs", force: :cascade do |t|
    t.string   "title",                 limit: 255
    t.string   "lang",                  limit: 255
    t.text     "description",           limit: 65535
    t.string   "slug",                  limit: 255
    t.integer  "product_category_id",   limit: 4
    t.integer  "product_collection_id", limit: 4
    t.integer  "product_id",            limit: 4
    t.datetime "created_at",                          null: false
    t.datetime "updated_at",                          null: false
    t.boolean  "archived",              limit: 1
  end

  add_index "product_langs", ["product_category_id"], name: "index_product_langs_on_product_category_id", using: :btree
  add_index "product_langs", ["product_collection_id"], name: "index_product_langs_on_product_collection_id", using: :btree
  add_index "product_langs", ["product_id"], name: "index_product_langs_on_product_id", using: :btree

  create_table "product_option_langs", force: :cascade do |t|
    t.string   "lang",              limit: 255
    t.integer  "product_option_id", limit: 4
    t.string   "name",              limit: 255
    t.datetime "created_at",                    null: false
    t.datetime "updated_at",                    null: false
    t.boolean  "archived",          limit: 1
  end

  add_index "product_option_langs", ["product_option_id"], name: "index_product_option_langs_on_product_option_id", using: :btree

  create_table "product_options", force: :cascade do |t|
    t.integer  "product_id", limit: 4
    t.datetime "created_at",           null: false
    t.datetime "updated_at",           null: false
    t.boolean  "archived",   limit: 1
  end

  add_index "product_options", ["product_id"], name: "index_product_options_on_product_id", using: :btree

  create_table "product_order_payments", force: :cascade do |t|
    t.integer  "product_order_payment_type_id", limit: 4
    t.integer  "product_order_id",              limit: 4
    t.decimal  "amount",                                    precision: 10
    t.string   "check_number",                  limit: 255
    t.string   "check_bank",                    limit: 255
    t.string   "payplug_payment_id",            limit: 255
    t.string   "payplug_card_id",               limit: 255
    t.string   "payplug_card_expiry_month",     limit: 255
    t.string   "payplug_card_expiry_year",      limit: 255
    t.string   "payplug_card_last_number",      limit: 255
    t.datetime "paid_at"
    t.datetime "tr_canceled_at"
    t.boolean  "tr_canceled",                   limit: 1,                  default: false
    t.string   "token",                         limit: 255
    t.datetime "created_at",                                                               null: false
    t.datetime "updated_at",                                                               null: false
  end

  create_table "product_order_products", force: :cascade do |t|
    t.integer  "product_order_id",           limit: 4
    t.integer  "product_id",                 limit: 4
    t.string   "name",                       limit: 255
    t.decimal  "price_ht",                               precision: 10, scale: 2
    t.decimal  "price_reduced_ht",                       precision: 10, scale: 2
    t.integer  "archived_product_id",        limit: 4
    t.decimal  "qty",                                    precision: 10
    t.decimal  "total",                                  precision: 10, scale: 2
    t.integer  "product_size_id",            limit: 4
    t.integer  "product_option_id",          limit: 4
    t.datetime "created_at",                                                      null: false
    t.datetime "updated_at",                                                      null: false
    t.integer  "archived_product_option_id", limit: 4
    t.integer  "archived_product_size_id",   limit: 4
  end

  create_table "product_orders", force: :cascade do |t|
    t.decimal  "amount",                                       precision: 10, scale: 2
    t.boolean  "particular_idem",                  limit: 1,                            default: false
    t.boolean  "paid",                             limit: 1,                            default: false
    t.integer  "particular_bill_id",               limit: 4
    t.string   "particular_send_id",               limit: 255
    t.string   "token",                            limit: 255
    t.boolean  "completed_finish",                 limit: 1,                            default: false
    t.integer  "product_order_payment_ok_id",      limit: 4
    t.integer  "product_order_payment_type_ok_id", limit: 4
    t.integer  "bill_index",                       limit: 4
    t.string   "bill_number",                      limit: 255
    t.string   "bill_year",                        limit: 255
    t.boolean  "bill_ok",                          limit: 1,                            default: false
    t.integer  "product_customer_id",              limit: 4
    t.datetime "paid_at"
    t.datetime "created_at",                                                                            null: false
    t.datetime "updated_at",                                                                            null: false
    t.integer  "product_fdp_id",                   limit: 4
    t.integer  "product_fdp_archived_id",          limit: 4
    t.boolean  "cgv",                              limit: 1
    t.integer  "vourcher_code_id",                 limit: 4
    t.integer  "vourcher_code_archived_id",        limit: 4
  end

  create_table "product_product_sizes", force: :cascade do |t|
    t.integer  "product_id",      limit: 4
    t.integer  "product_size_id", limit: 4
    t.datetime "created_at",                null: false
    t.datetime "updated_at",                null: false
  end

  add_index "product_product_sizes", ["product_id"], name: "index_product_product_sizes_on_product_id", using: :btree
  add_index "product_product_sizes", ["product_size_id"], name: "index_product_product_sizes_on_product_size_id", using: :btree

  create_table "product_sizes", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.integer  "position",   limit: 4
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
    t.boolean  "archived",   limit: 1
  end

  create_table "product_stocks", force: :cascade do |t|
    t.integer  "product_id",        limit: 4
    t.integer  "product_size_id",   limit: 4
    t.integer  "product_option_id", limit: 4
    t.integer  "stock",             limit: 4
    t.integer  "stock_th",          limit: 4
    t.datetime "created_at",                  null: false
    t.datetime "updated_at",                  null: false
  end

  add_index "product_stocks", ["product_id"], name: "index_product_stocks_on_product_id", using: :btree

  create_table "products", force: :cascade do |t|
    t.decimal  "price_ht",                        precision: 10, scale: 2
    t.decimal  "price_reduced_ht",                precision: 10, scale: 2
    t.boolean  "enabled",               limit: 1
    t.integer  "default_image_id",      limit: 4
    t.integer  "position",              limit: 4
    t.datetime "created_at",                                                               null: false
    t.datetime "updated_at",                                                               null: false
    t.integer  "product_category_id",   limit: 4
    t.integer  "product_collection_id", limit: 4
    t.boolean  "archived",              limit: 1,                          default: false
  end

  add_index "products", ["product_category_id"], name: "index_products_on_product_category_id", using: :btree
  add_index "products", ["product_collection_id"], name: "index_products_on_product_collection_id", using: :btree

  create_table "quote_contents", force: :cascade do |t|
    t.text     "quote",      limit: 65535
    t.string   "author",     limit: 255
    t.string   "color",      limit: 255
    t.string   "background", limit: 255
    t.string   "style",      limit: 255
    t.datetime "created_at",               null: false
    t.datetime "updated_at",               null: false
  end

  create_table "registrants", force: :cascade do |t|
    t.string   "token",      limit: 255
    t.string   "name",       limit: 255
    t.string   "surname",    limit: 255
    t.string   "email",      limit: 255
    t.boolean  "enabled",    limit: 1
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "table_contents", force: :cascade do |t|
    t.integer  "style",      limit: 4
    t.integer  "nbr_rows",   limit: 4
    t.integer  "nbr_cols",   limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "table_rows", force: :cascade do |t|
    t.integer  "position",         limit: 4
    t.integer  "style",            limit: 4
    t.integer  "table_content_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "tag_taggables", force: :cascade do |t|
    t.string   "taggable_type", limit: 255
    t.integer  "taggable_id",   limit: 4
    t.integer  "tag_id",        limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "tags", force: :cascade do |t|
    t.string   "name",          limit: 255
    t.string   "slug",          limit: 255
    t.integer  "parent_id",     limit: 4
    t.boolean  "public",        limit: 1
    t.string   "taggable_type", limit: 255
    t.integer  "taggable_id",   limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "text_contents", force: :cascade do |t|
    t.string   "style",      limit: 255
    t.text     "content",    limit: 65535
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "timeline_histories", force: :cascade do |t|
    t.string   "title",      limit: 255
    t.string   "slug",       limit: 255
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "title_contents", force: :cascade do |t|
    t.text     "content",    limit: 65535
    t.integer  "level",      limit: 4
    t.string   "style",      limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "alignement", limit: 255
  end

  create_table "tr_activities", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "code",       limit: 255
    t.string   "enabled",    limit: 255
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "tr_occasions", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "code",       limit: 255
    t.boolean  "enabled",    limit: 1
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "tr_payment_bank_accounts", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "code",       limit: 255
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "tr_payment_types", force: :cascade do |t|
    t.string   "name",       limit: 255
    t.string   "code",       limit: 255
    t.datetime "created_at",             null: false
    t.datetime "updated_at",             null: false
  end

  create_table "tr_payments", force: :cascade do |t|
    t.integer  "tr_payment_type_id",         limit: 4
    t.decimal  "amount",                                 precision: 10
    t.string   "check_number",               limit: 255
    t.string   "check_bank",                 limit: 255
    t.string   "payplug_payment_id",         limit: 255
    t.string   "payplug_card_id",            limit: 255
    t.string   "payplug_card_expiry_month",  limit: 255
    t.string   "payplug_card_expiry_year",   limit: 255
    t.string   "payplug_card_last_number",   limit: 255
    t.datetime "paid_at"
    t.datetime "tr_canceled_at"
    t.boolean  "tr_canceled",                limit: 1,                  default: false
    t.integer  "tr_payment_bank_account_id", limit: 4
    t.integer  "donator_transaction_id",     limit: 4
    t.datetime "created_at",                                                            null: false
    t.datetime "updated_at",                                                            null: false
  end

  create_table "translations", force: :cascade do |t|
    t.string   "locale",         limit: 255
    t.string   "key",            limit: 255
    t.text     "value",          limit: 65535
    t.text     "interpolations", limit: 65535
    t.boolean  "is_proc",        limit: 1,     default: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "video_contents", force: :cascade do |t|
    t.integer  "video_file_id", limit: 4
    t.string   "title",         limit: 255
    t.boolean  "download",      limit: 1
    t.boolean  "autoplay",      limit: 1
    t.boolean  "fullscreen",    limit: 1
    t.boolean  "controls",      limit: 1
    t.string   "legend",        limit: 255
    t.string   "style",         limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  add_index "video_contents", ["video_file_id"], name: "index_video_contents_on_video_file_id", using: :btree

  create_table "video_files", force: :cascade do |t|
    t.string   "title",           limit: 255
    t.text     "description",     limit: 65535
    t.string   "token",           limit: 255
    t.string   "poster",          limit: 255
    t.string   "mpg",             limit: 255
    t.string   "ogg",             limit: 255
    t.string   "webm",            limit: 255
    t.string   "youtube_link",    limit: 255
    t.string   "youtube_code",    limit: 255
    t.integer  "video_folder_id", limit: 4
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "slug",            limit: 255
    t.integer  "image_file_id",   limit: 4
  end

  add_index "video_files", ["image_file_id"], name: "index_video_files_on_image_file_id", using: :btree
  add_index "video_files", ["video_folder_id"], name: "index_video_files_on_video_folder_id", using: :btree

  create_table "video_folders", force: :cascade do |t|
    t.string   "name",        limit: 255
    t.boolean  "super_admin", limit: 1
    t.text     "description", limit: 65535
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "virement_remises", force: :cascade do |t|
    t.string   "token",            limit: 255
    t.decimal  "amount",                       precision: 10, scale: 2
    t.integer  "virement_type_id", limit: 4
    t.boolean  "sended",           limit: 1
    t.boolean  "confirmed",        limit: 1
    t.string   "note",             limit: 255
    t.datetime "created_at",                                            null: false
    t.datetime "updated_at",                                            null: false
    t.integer  "devise_id",        limit: 4
  end

  add_index "virement_remises", ["devise_id"], name: "index_virement_remises_on_devise_id", using: :btree

  create_table "virements", force: :cascade do |t|
    t.string   "token",               limit: 255
    t.integer  "virement_type_id",    limit: 4
    t.boolean  "sended",              limit: 1
    t.boolean  "confirmed",           limit: 1
    t.boolean  "done",                limit: 1
    t.string   "note",                limit: 255
    t.integer  "product_customer_id", limit: 4
    t.integer  "virement_remise_id",  limit: 4
    t.decimal  "amount_ht",                       precision: 10, scale: 2
    t.decimal  "amount_ttc",                      precision: 10, scale: 2
    t.decimal  "tva",                             precision: 10, scale: 2
    t.decimal  "frais",                           precision: 10
    t.decimal  "solde",                           precision: 10
    t.integer  "commission_id",       limit: 4
    t.integer  "account_rib_id",      limit: 4
    t.datetime "created_at",                                               null: false
    t.datetime "updated_at",                                               null: false
    t.integer  "devise_id",           limit: 4
  end

  add_index "virements", ["account_rib_id"], name: "index_virements_on_account_rib_id", using: :btree
  add_index "virements", ["commission_id"], name: "index_virements_on_commission_id", using: :btree
  add_index "virements", ["devise_id"], name: "index_virements_on_devise_id", using: :btree
  add_index "virements", ["product_customer_id"], name: "index_virements_on_product_customer_id", using: :btree
  add_index "virements", ["virement_remise_id"], name: "index_virements_on_virement_remise_id", using: :btree

  create_table "vourcher_codes", force: :cascade do |t|
    t.boolean  "archived",       limit: 1,                             default: false
    t.string   "slug",           limit: 255
    t.decimal  "percent",                    precision: 15, scale: 10
    t.decimal  "amount",                     precision: 15, scale: 10
    t.boolean  "enabled",        limit: 1,                             default: false
    t.decimal  "minimal_amount",             precision: 15, scale: 10
    t.datetime "created_at",                                                           null: false
    t.datetime "updated_at",                                                           null: false
  end

  add_foreign_key "articles", "article_authors"
  add_foreign_key "block_contents", "image_files"
  add_foreign_key "commissions", "devises"
  add_foreign_key "commissions", "product_customers"
  add_foreign_key "data_files", "image_files"
  add_foreign_key "home_slider_slides", "home_sliders"
  add_foreign_key "lang_pages", "lang_sites"
  add_foreign_key "lang_pages", "pages"
  add_foreign_key "menu_item_langs", "lang_sites"
  add_foreign_key "product_category_langs", "product_categories"
  add_foreign_key "product_collection_langs", "product_collections"
  add_foreign_key "product_collections", "product_categories"
  add_foreign_key "product_images", "image_files"
  add_foreign_key "product_langs", "product_categories"
  add_foreign_key "product_langs", "product_collections"
  add_foreign_key "product_option_langs", "product_options"
  add_foreign_key "product_options", "products"
  add_foreign_key "product_product_sizes", "product_sizes"
  add_foreign_key "product_product_sizes", "products"
  add_foreign_key "product_stocks", "products"
  add_foreign_key "products", "product_categories"
  add_foreign_key "products", "product_collections"
  add_foreign_key "video_files", "image_files"
  add_foreign_key "virement_remises", "devises"
  add_foreign_key "virements", "devises"
end
